<template>
  <div>
    <v-row v-if="formState.ready" dense>
      <v-col>
        <v-form ref="form">
          <v-tabs v-model="tab" mobile-breakpoint="100">
            <v-tab>{{ $ay.t("NotifyEventType") }}</v-tab>
            <v-tab>{{ $ay.t("OpsNotificationSettings") }}</v-tab>
            <v-tabs-items v-model="tab">
              <v-tab-item class="mt-4 ml-2">
                <v-row dense>
                  <gz-error
                    :error-box-message="formState.errorBoxMessage"
                  ></gz-error>

                  <v-col cols="12" sm="6" lg="4" xl="3">
                    <v-select
                      ref="eventType"
                      v-model="obj.eventType"
                      dense
                      :items="selectLists.eventTypes"
                      item-text="name"
                      item-value="id"
                      :readonly="formState.readOnly"
                      :label="$ay.t('NotifyEventType')"
                      data-cy="eventType"
                      :rules="[form().integerValid(this, 'eventType')]"
                      :error-messages="form().serverErrors(this, 'eventType')"
                      @input="fieldValueChanged('eventType')"
                    ></v-select>
                  </v-col>
                  <v-col cols="12" sm="6" lg="4" xl="3">
                    <gz-tag-picker
                      ref="customerTags"
                      v-model="obj.customerTags"
                      :label="$ay.t('CustomerTags')"
                      :readonly="formState.readOnly"
                      data-cy="customerTags"
                      :error-messages="
                        form().serverErrors(this, 'customerTags')
                      "
                      @input="fieldValueChanged('customerTags')"
                    ></gz-tag-picker>
                  </v-col>
                  <v-col v-if="showWoStatus" cols="12" sm="6" lg="4" xl="3">
                    <v-autocomplete
                      v-model="obj.idValue"
                      dense
                      :items="selectLists.wostatus"
                      item-text="name"
                      item-value="id"
                      :label="$ay.t('WorkOrderStatus')"
                      @input="fieldValueChanged('idValue')"
                    >
                      <template v-slot:item="data">
                        <v-list-item-avatar>
                          <v-icon :color="data.item.color">$ayiFlag</v-icon>
                        </v-list-item-avatar>
                        <v-list-item-content>
                          <v-list-item-title
                            ><span class="text-subtitle-2">{{
                              data.item.name
                            }}</span
                            ><v-icon
                              v-if="data.item.locked"
                              small
                              color="disabled"
                              class="ml-2"
                              >$ayiLock</v-icon
                            >
                            <v-icon
                              v-if="data.item.completed"
                              color="disabled"
                              class="ml-1"
                              small
                              >$ayiCheckCircle</v-icon
                            ></v-list-item-title
                          >
                          <v-list-item-subtitle>
                            {{ data.item.notes }}</v-list-item-subtitle
                          >
                        </v-list-item-content>
                        <v-list-item-action> </v-list-item-action>
                      </template>
                    </v-autocomplete>
                  </v-col>
                  <v-col v-if="showQuoteStatus" cols="12" sm="6" lg="4" xl="3">
                    <v-autocomplete
                      v-model="obj.idValue"
                      dense
                      :items="selectLists.quotestatus"
                      item-text="name"
                      item-value="id"
                      :label="$ay.t('QuoteQuoteStatusType')"
                      @input="fieldValueChanged('idValue')"
                    >
                      <template v-slot:item="data">
                        <v-list-item-avatar>
                          <v-icon :color="data.item.color">$ayiFlag</v-icon>
                        </v-list-item-avatar>
                        <v-list-item-content>
                          <v-list-item-title
                            ><span class="text-subtitle-2">{{
                              data.item.name
                            }}</span
                            ><v-icon
                              v-if="data.item.locked"
                              small
                              color="disabled"
                              class="ml-2"
                              >$ayiLock</v-icon
                            >
                            <v-icon
                              v-if="data.item.completed"
                              color="disabled"
                              class="ml-1"
                              small
                              >$ayiCheckCircle</v-icon
                            ></v-list-item-title
                          >
                          <v-list-item-subtitle>
                            {{ data.item.notes }}</v-list-item-subtitle
                          >
                        </v-list-item-content>
                        <v-list-item-action> </v-list-item-action>
                      </template>
                    </v-autocomplete>
                  </v-col>

                  <v-col v-if="showDecValue" cols="12" sm="6" lg="4" xl="3">
                    <gz-decimal
                      ref="decValue"
                      v-model="obj.decValue"
                      :readonly="formState.readOnly"
                      :label="$ay.t('Total')"
                      data-cy="decValue"
                      :rules="[
                        form().decimalValid(this, 'decValue'),
                        form().required(this, 'decValue')
                      ]"
                      :error-messages="form().serverErrors(this, 'decValue')"
                      @input="fieldValueChanged('decValue')"
                    ></gz-decimal>
                  </v-col>

                  <v-col
                    v-if="showIntegerDecValue"
                    cols="12"
                    sm="6"
                    lg="4"
                    xl="3"
                  >
                    <v-text-field
                      ref="decValue"
                      v-model="obj.decValue"
                      dense
                      :readonly="formState.readOnly"
                      :clearable="!formState.readOnly"
                      :label="$ay.t('UiFieldDataTypesInteger')"
                      data-cy="decValue"
                      :rules="[form().integerValid(this, 'decValue')]"
                      :error-messages="form().serverErrors(this, 'decValue')"
                      type="number"
                      @click:clear="fieldValueChanged('decValue')"
                      @input="fieldValueChanged('decValue')"
                    ></v-text-field>
                  </v-col>

                  <v-col v-if="showAgeValue" cols="12" sm="6" lg="4" xl="3">
                    <gz-duration-picker
                      ref="ageValue"
                      v-model="obj.ageValue"
                      :readonly="formState.readOnly"
                      :label="$ay.t('Duration')"
                      :show-seconds="false"
                      data-cy="ageValue"
                      :error-messages="form().serverErrors(this, 'ageValue')"
                      @input="fieldValueChanged('ageValue')"
                    ></gz-duration-picker>
                  </v-col>

                  <v-col
                    v-if="showAdvanceNotice"
                    cols="12"
                    sm="6"
                    lg="4"
                    xl="3"
                  >
                    <gz-duration-picker
                      ref="advanceNotice"
                      v-model="obj.advanceNotice"
                      :readonly="formState.readOnly"
                      :label="$ay.t('NotifySubscriptionPendingSpan')"
                      :show-seconds="false"
                      data-cy="advanceNotice"
                      :error-messages="
                        form().serverErrors(this, 'advanceNotice')
                      "
                      @input="fieldValueChanged('advanceNotice')"
                    ></gz-duration-picker>
                  </v-col>

                  <v-col
                    v-if="showWorkOrderReportSelector"
                    cols="12"
                    sm="6"
                    lg="4"
                    xl="3"
                  >
                    <gz-pick-list
                      ref="linkReportId"
                      v-model="obj.linkReportId"
                      :aya-type="ayaTypes().Report"
                      :variant="ayaTypes().WorkOrder.toString()"
                      :readonly="formState.readOnly"
                      :label="$ay.t('AttachReport')"
                      data-cy="linkReportId"
                      :error-messages="
                        form().serverErrors(this, 'linkReportId')
                      "
                      @input="fieldValueChanged('linkReportId')"
                    ></gz-pick-list>
                  </v-col>

                  <v-col
                    v-if="showQuoteReportSelector"
                    cols="12"
                    sm="6"
                    lg="4"
                    xl="3"
                  >
                    <gz-pick-list
                      ref="linkQuoteReportId"
                      v-model="obj.linkReportId"
                      :aya-type="ayaTypes().Report"
                      :variant="ayaTypes().Quote.toString()"
                      :readonly="formState.readOnly"
                      :label="$ay.t('AttachReport')"
                      data-cy="linkReportId"
                      :error-messages="
                        form().serverErrors(this, 'linkReportId')
                      "
                      @input="fieldValueChanged('linkReportId')"
                    ></gz-pick-list>
                  </v-col>

                  <v-col cols="12" sm="6" lg="4" xl="3">
                    <gz-tag-picker
                      ref="tags"
                      v-model="obj.tags"
                      :label="objectTagsTitle()"
                      :readonly="formState.readOnly"
                      data-cy="tags"
                      :error-messages="form().serverErrors(this, 'tags')"
                      @input="fieldValueChanged('tags')"
                    ></gz-tag-picker>
                  </v-col>

                  <v-col cols="12">
                    <v-text-field
                      ref="subject"
                      v-model="obj.subject"
                      dense
                      :readonly="formState.readOnly"
                      :label="$ay.t('EmailSubject')"
                      :rules="[form().required(this, 'subject')]"
                      :error-messages="form().serverErrors(this, 'subject')"
                      @input="fieldValueChanged('subject')"
                      @focus="currentTemplateField = 'subject'"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12">
                    <v-textarea
                      ref="template"
                      v-model="obj.template"
                      dense
                      :readonly="formState.readOnly"
                      :label="$ay.t('EmailTemplate')"
                      :rules="[form().required(this, 'template')]"
                      :error-messages="form().serverErrors(this, 'template')"
                      data-cy="template"
                      auto-grow
                      @input="fieldValueChanged('template')"
                      @focus="currentTemplateField = 'template'"
                    ></v-textarea>
                  </v-col>
                  <v-col
                    v-if="showWorkOrderTokenSelector"
                    cols="12"
                    sm="6"
                    lg="4"
                    xl="3"
                  >
                    <v-select
                      v-model="woToken"
                      dense
                      prepend-icon="$ayiPlus"
                      :items="selectLists.workOrderTemplateTokens"
                      item-text="name"
                      item-value="id"
                      :label="$ay.t('TemplateTokens')"
                      @click:prepend="insertToken(woToken)"
                    ></v-select>
                  </v-col>

                  <v-col
                    v-if="showQuoteTokenSelector"
                    cols="12"
                    sm="6"
                    lg="4"
                    xl="3"
                  >
                    <v-select
                      v-model="quoteToken"
                      dense
                      prepend-icon="$ayiPlus"
                      :items="selectLists.quoteTemplateTokens"
                      item-text="name"
                      item-value="id"
                      :label="$ay.t('TemplateTokens')"
                      @click:prepend="insertToken(quoteToken)"
                    ></v-select>
                  </v-col>

                  <v-col
                    v-if="showCSRTokenSelector"
                    cols="12"
                    sm="6"
                    lg="4"
                    xl="3"
                  >
                    <v-select
                      v-model="csrToken"
                      dense
                      prepend-icon="$ayiPlus"
                      :items="selectLists.csrTemplateTokens"
                      item-text="name"
                      item-value="id"
                      :label="$ay.t('TemplateTokens')"
                      @click:prepend="insertToken(csrToken)"
                    ></v-select>
                  </v-col>
                </v-row>
              </v-tab-item>
              <v-tab-item class="mt-4 ml-2">
                <v-row dense>
                  <v-col cols="12" sm="6" lg="4" xl="3">
                    <v-select
                      ref="translationId"
                      v-model="obj.translationId"
                      dense
                      :items="selectLists.translations"
                      item-text="name"
                      item-value="id"
                      :readonly="formState.readOnly"
                      :label="$ay.t('Translation')"
                      :rules="[form().required(this, 'translationId')]"
                      :error-messages="
                        form().serverErrors(this, 'translationId')
                      "
                      @input="fieldValueChanged('translationId')"
                    ></v-select>
                  </v-col>

                  <v-col cols="12" sm="6" lg="4" xl="3">
                    <v-checkbox
                      ref="hour12"
                      v-model="obj.hour12"
                      dense
                      :readonly="formState.readOnly"
                      :label="$ay.t('Hour12')"
                      :error-messages="form().serverErrors(this, 'hour12')"
                      @change="fieldValueChanged('hour12')"
                    ></v-checkbox>
                  </v-col>

                  <v-col cols="12" sm="6" lg="4" xl="3">
                    <v-text-field
                      ref="currencyName"
                      v-model="obj.currencyName"
                      dense
                      :hint="
                        obj.currencyName == null || obj.currencyName == ''
                          ? locale().getCurrencyName()
                          : ''
                      "
                      persistent-hint
                      :readonly="formState.readOnly"
                      :label="$ay.t('CurrencyCode')"
                      :rules="[form().required(this, 'currencyName')]"
                      :error-messages="
                        form().serverErrors(this, 'currencyName')
                      "
                      append-outer-icon="$ayiQuestionCircle"
                      @input="fieldValueChanged('currencyName')"
                      @click:append-outer="goHelp()"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" sm="6" lg="4" xl="3">
                    <v-text-field
                      ref="languageOverride"
                      v-model="obj.languageOverride"
                      dense
                      :hint="locale().getResolvedLanguage()"
                      persistent-hint
                      :readonly="formState.readOnly"
                      :label="$ay.t('LanguageCode')"
                      :rules="[form().required(this, 'languageOverride')]"
                      :error-messages="
                        form().serverErrors(this, 'languageOverride')
                      "
                      append-outer-icon="$ayiQuestionCircle"
                      @input="fieldValueChanged('languageOverride')"
                      @click:append-outer="goHelp()"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" sm="6" lg="4" xl="3">
                    <v-text-field
                      ref="timeZoneOverride"
                      v-model="obj.timeZoneOverride"
                      dense
                      :hint="locale().getResolvedTimeZoneName()"
                      persistent-hint
                      :readonly="formState.readOnly"
                      :label="$ay.t('TimeZone')"
                      :rules="[form().required(this, 'timeZoneOverride')]"
                      :error-messages="
                        form().serverErrors(this, 'timeZoneOverride')
                      "
                      append-outer-icon="$ayiQuestionCircle"
                      @input="fieldValueChanged('timeZoneOverride')"
                      @click:append-outer="goHelp()"
                    ></v-text-field>
                  </v-col>
                </v-row>
              </v-tab-item>
            </v-tabs-items>
          </v-tabs>
        </v-form>
      </v-col>
      <v-dialog
        v-model="whoDialog"
        scrollable
        max-width="600px"
        @keydown.esc="cancel"
      >
        <v-card elevation="24">
          <v-card-title class="text-h5 lighten-2" primary-title>
            <v-badge left class="mt-1">
              <template v-slot:badge>
                {{ whoList.length }}
              </template>
              <span> {{ $ay.t("WhoWillBeNotified") }} </span>
            </v-badge>
          </v-card-title>

          <v-card-text>
            <v-sheet class="mt-1 overflow-y-auto">
              <div
                v-if="whoList.length == 0"
                class="ml-6 mt-6 text-h4 grey--text text--lighten-1"
              >
                {{ $ay.t("NoData") }}
              </div>
              <v-list>
                <template v-for="(item, i) in whoList">
                  <v-list-item :key="i" :to="'/cust-customers/' + item.id">
                    <v-list-item-content>
                      <v-list-item-title>
                        <span
                          v-if="item.emailAddress == ''"
                          class="ml-4 accent--text font-weight-bold font-italic"
                          >{{ item.name }}</span
                        >
                        <span v-else class="ml-4">{{ item.name }}</span>
                        <span class="ml-4">{{
                          item.emailAddress
                        }}</span></v-list-item-title
                      >
                    </v-list-item-content>
                  </v-list-item>
                </template>
              </v-list>
            </v-sheet>
          </v-card-text>

          <v-card-actions>
            <v-btn color="primary" text @click.native="whoDialog = false">{{
              $ay.t("Close")
            }}</v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-row>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
  </div>
</template>
<script>
const FORM_KEY = "customer-notify-subscription";
const API_BASE_URL = "customer-notify-subscription/";
export default {
  data() {
    return {
      selectLists: {
        wostatus: [],
        quotestatus: [],
        eventTypes: [],
        translations: [],
        workOrderTemplateTokens: [],
        quoteTemplateTokens: [],
        csrTemplateTokens: []
      },
      obj: {
        id: 0,
        concurrency: 0,
        languageOverride: window.$gz.locale.getResolvedLanguage(),
        timeZoneOverride: window.$gz.locale.getResolvedTimeZoneName(),
        currencyName: window.$gz.locale.getCurrencyName(),
        hour12: window.$gz.locale.getHour12(),
        translationId: 3,
        ayaType: 0,
        eventType: 0,
        advanceNotice: "00:00:00",
        ageValue: "00:00:00",
        idValue: 0,
        decValue: 0,
        linkReportId: null,
        tags: [],
        customerTags: [],
        template: null,
        subject: null
      },

      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      ayaType: window.$gz.type.CustomerNotifySubscription,
      tab: 0,
      whoDialog: false,
      whoList: [],
      woToken: null,
      quoteToken: null,
      csrToken: null,
      currentTemplateField: null
    };
  },
  computed: {
    showDeliveryAddress() {
      return this.obj.deliveryMethod == 2;
    },
    showDeliveryMethod() {
      return this.obj.eventType != 27;
    },
    showWoStatus() {
      switch (this.obj.eventType) {
        case 4:
        case 24:
          return true;
        default:
          return false;
      }
    },
    showQuoteStatus() {
      switch (this.obj.eventType) {
        case 9:
        case 29:
          return true;
        default:
          return false;
      }
    },
    showDecValue() {
      //WorkorderTotalExceedsThreshold = 23 The "Andy"
      return this.obj.eventType == 23; // || this.obj.eventType == 11; //service bank threshold
    },
    showIntegerDecValue() {
      //UnitMeterReadingMultipleExceeded=26,
      return this.obj.eventType == 26;
    },

    showAdvanceNotice() {
      switch (this.obj.eventType) {
        case 5:
        case 11:
        case 12:
        case 14:
        case 16:
        case 21:
        case 22:
        case 25:
        case 34:
          return true;
        default:
          return false;
      }
    },
    showAgeValue() {
      switch (this.obj.eventType) {
        case 24:
        case 29:
        case 10:
          return true;
        default:
          return false;
      }
    },
    showWorkOrderReportSelector() {
      //## MUST ALSO UPDATE CoreJobCustomerNotify check for reportable event if add here
      switch (this.obj.eventType) {
        case 4: //WorkorderStatusChange = 4
        case 30: //workorder completed
          return true;
        default:
          return false;
      }
    },
    showQuoteReportSelector() {
      //## MUST ALSO UPDATE CoreJobCustomerNotify check for reportable event if add here
      switch (this.obj.eventType) {
        case 9: //quote status changed
          return true;
        default:
          return false;
      }
    },
    showWorkOrderTokenSelector() {
      switch (this.obj.eventType) {
        case 4: //WorkorderStatusChange = 4
          return true;
        // case 6: //notifyCSRAccepted;
        //   return true;
        // case 7: //notifyCSRRejected;
        //   return true;
        // case 9: //QuoteStatusChange = 9
        //   return true;
        case 21: //notifyServiceImminent;
          return true;
        case 24: //WorkorderStatusAge = 24  This is to replace the v7 wo follow up x days after closed notification to send message for follow up after closed
          return true;
        case 30: //notifyWOCompleted;
          return true;
        case 31: //notifyWOCreated;
          return true;
        default:
          return false;
      }
    },
    showQuoteTokenSelector() {
      switch (this.obj.eventType) {
        // case 4: //WorkorderStatusChange = 4
        //   return true;
        // case 6: //notifyCSRAccepted;
        //   return true;
        // case 7: //notifyCSRRejected;
        //   return true;
        case 9: //QuoteStatusChange = 9
          return true;
        // case 21: //notifyServiceImminent;
        //   return true;
        // case 24: //WorkorderStatusAge = 24  This is to replace the v7 wo follow up x days after closed notification to send message for follow up after closed
        //   return true;
        // case 30: //notifyWOCompleted;
        //   return true;
        // case 31: //notifyWOCreated;
        //   return true;
        default:
          return false;
      }
    },
    showCSRTokenSelector() {
      switch (this.obj.eventType) {
        // case 4: //WorkorderStatusChange = 4
        //   return true;
        case 6: //notifyCSRAccepted;
          return true;
        case 7: //notifyCSRRejected;
          return true;
        // case 9: //QuoteStatusChange = 9
        //   return true;
        // case 21: //notifyServiceImminent;
        //   return true;
        // case 24: //WorkorderStatusAge = 24  This is to replace the v7 wo follow up x days after closed notification to send message for follow up after closed
        //   return true;
        // case 30: //notifyWOCompleted;
        //   return true;
        // case 31: //notifyWOCreated;
        //   return true;
        default:
          return false;
      }
    }
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }
        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }
        if (!val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;
    try {
      await initForm(vm);
      vm.rights = window.$gz.role.getRights(
        window.$gz.type.CustomerNotifySubscription
      );
      vm.formState.readOnly = !vm.rights.change;
      window.$gz.eventBus.$on("menu-click", clickHandler);
      let setDirty = false;
      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        //Might be a duplicate and contain another record
        if (this.$route.params.obj) {
          this.obj = this.$route.params.obj;
          this.obj.concurrency = undefined;
          this.obj.id = 0;
          setDirty = true;
        } else {
          //default to their configured email address on new record
          this.obj.deliveryAddress = this.$store.state.userOptions.emailAddress;
        }
      }
      window.$gz.form.setFormState({
        vm: vm,
        loading: false,
        dirty: setDirty,
        valid: true
      });
      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    insertToken(t) {
      switch (this.currentTemplateField) {
        case "template":
          {
            const bodyTextArea = this.$refs.template.$el.querySelector(
              "textarea"
            );
            const start = bodyTextArea.selectionStart;
            this.obj.template = window.$gz.util.stringSplice(
              this.obj.template,
              start,
              0,
              t
            );
          }
          break;
        case "subject":
          {
            const inputText = this.$refs.subject.$el.querySelector("input");
            const start = inputText.selectionStart;
            this.obj.subject = window.$gz.util.stringSplice(
              this.obj.subject,
              start,
              0,
              t
            );
          }
          break;
      }
    },
    objectTagsTitle() {
      let objectName = null;
      switch (this.obj.eventType) {
        case 4: //WorkorderStatusChange = 4
          objectName = this.$ay.t("WorkOrder");
          break;
        case 6: //notifyCSRAccepted;
          objectName = this.$ay.t("CustomerServiceRequest");
          break;
        case 7: //notifyCSRRejected;
          objectName = this.$ay.t("CustomerServiceRequest");
          break;
        case 9: //QuoteStatusChange = 9
          objectName = this.$ay.t("Quote");
          break;
        case 21: //notifyServiceImminent;
          objectName = this.$ay.t("WorkOrder");
          break;
        case 24: //WorkorderStatusAge = 24  This is to replace the v7 wo follow up x days after closed notification to send message for follow up after closed
          objectName = this.$ay.t("WorkOrder");
          break;
        case 30: //notifyWOCompleted;
          objectName = this.$ay.t("WorkOrder");
          break;
        case 31: //notifyWOCreated;
          objectName = this.$ay.t("WorkOrder");
          break;
        default:
          return this.$ay.t("TaggedWith");
      }
      return objectName + " - " + this.$ay.t("TaggedWith");
    },
    goHelp() {
      window.open(
        window.$gz.api.helpUrl() +
          "customer-notify-subscriptions#notification-settings",
        "_blank"
      );
    },
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    },
    canDuplicate: function() {
      return this.formState.valid && !this.formState.dirty;
    },
    ayaTypes: function() {
      return window.$gz.type;
    },
    locale() {
      return window.$gz.locale;
    },
    form() {
      return window.$gz.form;
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        //if it's a general notification make sure delivery is set to email
        if (ref == "eventType" && this.obj.eventType == 27) {
          this.obj.deliveryMethod = 2;
        }
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      vm.formState.loading = true;
      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
          vm.formState.loading = false;
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false,
            readOnly: res.data.eventType == 27 && res.data.deliveryMethod == 1 //default in-app notification is read only
          });
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
        vm.formState.loading = false;
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }

      try {
        vm.formState.loading = true;
        window.$gz.form.deleteAllErrorBoxErrors(vm);

        //don't include invalid settings (could be set by duplicate option)
        if (
          !this.showWorkOrderReportSelector &&
          !this.showQuoteReportSelector
        ) {
          vm.obj.linkReportId = null;
        }

        if (!this.showAgeValue) {
          this.obj.ageValue = "00:00:00";
        }
        if (!this.showAdvanceNotice) {
          this.obj.advanceNotice = "00:00:00";
        }
        if (!this.showDecValue && !this.showIntegerDecValue) {
          this.obj.decValue = 0;
        }

        if (!this.showQuoteStatus && !this.showWoStatus) {
          this.obj.idValue = 0;
        }

        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            this.$router.replace({
              name: "cust-notify-subscription",
              params: {
                recordid: res.data.id,
                obj: res.data
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        vm.formState.loading = false;
      }
    },
    async remove() {
      try {
        const dialogResult = await window.$gz.dialog.confirmDelete();
        if (dialogResult != true) {
          return;
        }
        this.formState.loading = true;
        if (this.$route.params.recordid == 0) {
          JUST_DELETED = true;
          this.$router.go(-1);
        } else {
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.remove(
            API_BASE_URL + this.$route.params.recordid
          );
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            JUST_DELETED = true;
            this.$router.go(-1);
          }
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, this);
      } finally {
        this.formState.loading = false;
      }
    },

    async who() {
      try {
        this.formState.loading = true;
        if (this.$route.params.recordid == 0) {
          return;
        } else {
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.post(
            API_BASE_URL + "who",
            this.obj.customerTags
          );
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            this.whoList = res.data;
            this.whoDialog = true;
          }
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, this);
      } finally {
        this.formState.loading = false;
      }
    },
    duplicate() {
      this.$router.push({
        name: "cust-notify-subscription",
        params: {
          recordid: 0,
          obj: this.obj
        }
      });
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;
      case "delete":
        m.vm.remove();
        break;
      case "new":
        m.vm.$router.push({
          name: "cust-notify-subscription",
          params: { recordid: 0 }
        });
        break;
      case "duplicate":
        m.vm.duplicate();
        break;
      case "who":
        m.vm.who();
        break;
      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly,
    icon: "$ayiBullhorn",
    title: "CustomerNotifySubscription",
    helpUrl: "customer-notify-subscriptions",
    formData: {
      ayaType: window.$gz.type.CustomerNotifySubscription,
      recordId: vm.$route.params.recordid
    },
    menuItems: []
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$ayiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "New",
      icon: "$ayiPlus",
      key: FORM_KEY + ":new",
      vm: vm
    });
  }

  if (vm.rights.change && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Duplicate",
      icon: "$ayiClone",
      key: FORM_KEY + ":duplicate",
      vm: vm
    });
  }

  if (vm.rights.delete && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Delete",
      icon: "$ayiTrashAlt",
      surface: false,
      key: FORM_KEY + ":delete",
      vm: vm
    });
  }

  if (vm.rights.change && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({ divider: true, inset: false });
    menuOptions.menuItems.push({
      title: "WhoWillBeNotified",
      icon: null,
      key: FORM_KEY + ":who",
      vm: vm
    });
  }

  menuOptions.menuItems.push({ divider: true, inset: false });
  window.$gz.eventBus.$emit("menu-change", menuOptions);
}

let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm(vm) {
  await fetchTranslatedText();
  await populateSelectionLists(vm);
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "NotifySubscriptionPendingSpan",
    "CustomerNotifySubscription",
    "NotifyEventType",
    "Tags",
    "Duration",
    "TaggedWith",
    "WorkOrderStatus",
    "Total",
    "UiFieldDataTypesInteger",
    "QuoteQuoteStatusType",
    "AttachReport",
    "OpsNotificationSettings",
    "NotifyEventType",
    "CurrencyCode",
    "LanguageCode",
    "TimeZone",
    "Hour12",
    "Translation",
    "CustomerServiceRequest",
    "WorkOrder",
    "Quote",
    "WhoWillBeNotified",
    "EmailTemplate",
    "Customer",
    "WorkOrderCustomerContactName",
    "WorkOrderCustomerReferenceNumber",
    "WorkOrderSummary",
    "WorkOrderSerialNumber",
    "Name",
    "TemplateTokens",
    "QuoteSerialNumber",
    "QuoteIntroduction",
    "QuoteQuoteRequestDate",
    "QuoteValidUntilDate",
    "EmailSubject",
    "CustomerServiceRequestRequestedBy",
    "CustomerServiceRequestCustomerReferenceNumber",
    "CustomerServiceRequestTitle"
  ]);
}

//////////////////////
//
//
async function populateSelectionLists(vm) {
  //ensure the pick lists required are pre-fetched
  await window.$gz.enums.fetchEnumList("NotifyEventType");
  const tempEventTypes = window.$gz.enums.getSelectionList("NotifyEventType");

  vm.selectLists.eventTypes = tempEventTypes.filter(z => {
    //return true if it's a type allowed for customer
    switch (z.id) {
      case 4: //WorkorderStatusChange = 4
        return true;
      case 6: //notifyCSRAccepted;
        return true;
      case 7: //notifyCSRRejected;
        return true;
      case 9: //QuoteStatusChange = 9
        return true;
      case 21: //notifyServiceImminent;
        return true;
      case 24: //WorkorderStatusAge = 24  This is to replace the v7 wo follow up x days after closed notification to send message for follow up after closed
        return true;
      case 30: //notifyWOCompleted;
        return true;
      case 31: //notifyWOCreated;
        return true;
      default:
        return false;
    }
  });

  let res = await window.$gz.api.get("work-order-status/list");
  if (res.error) {
    vm.formState.serverError = res.error;
    window.$gz.form.setErrorBoxErrors(vm);
  } else {
    vm.selectLists.wostatus = res.data.all;
  }

  res = await window.$gz.api.get("quote-status/list");
  if (res.error) {
    vm.formState.serverError = res.error;
    window.$gz.form.setErrorBoxErrors(vm);
  } else {
    vm.selectLists.quotestatus = res.data.all;
  }

  res = await window.$gz.api.get("translation/list");
  if (res.error) {
    vm.formState.serverError = res.error;
    window.$gz.form.setErrorBoxErrors(vm);
  } else {
    vm.selectLists.translations = res.data;
  }

  //get current user's translation id to use as default
  res = await window.$gz.api.get("user-option/" + vm.$store.state.userId);
  if (res.error) {
    vm.formState.serverError = res.error;
    window.$gz.form.setErrorBoxErrors(vm);
  } else {
    vm.obj.translationId = res.data.translationId;
  }

  /*Template tokens
workorder: 
[Client.Label.Name] - Client name, [O.WorkorderStatus] - Workorder status, [Workorder.Label.CustomerContactName] - Contact,
[Workorder.Label.CustomerReferenceNumber] - Client Reference #, [Workorder.Label.Summary] - Summary,[WorkorderService.Label.ServiceNumber] - Service Number

Quote:
[Client.Label.Name] - Client name,[WorkorderQuote.Label.QuoteNumber] - Quote Number

CSR: 
[Client.Label.Name] - Client name,[ClientServiceRequest.Label.Title] - Title

*/
  const wo = vm.$ay.t("WorkOrder") + " ";
  const quote = vm.$ay.t("Quote") + " ";
  const csr = vm.$ay.t("CustomerServiceRequest") + " ";
  const cust = vm.$ay.t("Customer") + " ";

  vm.selectLists.workOrderTemplateTokens.push(
    ...[
      { name: cust + vm.$ay.t("Name"), id: "{{Customer}}" },
      {
        name: vm.$ay.t("WorkOrderStatus"),
        id: "{{WorkOrderStatus}}"
      },
      {
        name: wo + vm.$ay.t("WorkOrderCustomerContactName"),
        id: "{{WorkOrderCustomerContactName}}"
      },
      {
        name: vm.$ay.t("WorkOrderCustomerReferenceNumber"),
        id: "{{WorkOrderCustomerReferenceNumber}}"
      },
      {
        name: wo + vm.$ay.t("WorkOrderSummary"),
        id: "{{WorkOrderSummary}}"
      },
      {
        name: wo + vm.$ay.t("WorkOrderSerialNumber"),
        id: "{{WorkOrderSerialNumber}}"
      }
    ].sort(window.$gz.util.sortByKey("name"))
  );

  vm.selectLists.quoteTemplateTokens.push(
    ...[
      { name: cust + vm.$ay.t("Name"), id: "{{Customer}}" },
      {
        name: vm.$ay.t("QuoteIntroduction"),
        id: "{{QuoteIntroduction}}"
      },
      {
        name: wo + vm.$ay.t("WorkOrderCustomerContactName"),
        id: "{{WorkOrderCustomerContactName}}"
      },
      {
        name: vm.$ay.t("WorkOrderCustomerReferenceNumber"),
        id: "{{WorkOrderCustomerReferenceNumber}}"
      },
      {
        name: wo + vm.$ay.t("WorkOrderSummary"),
        id: "{{WorkOrderSummary}}"
      },
      {
        name: quote + vm.$ay.t("QuoteSerialNumber"),
        id: "{{QuoteSerialNumber}}"
      }
    ].sort(window.$gz.util.sortByKey("name"))
  );

  vm.selectLists.csrTemplateTokens.push(
    ...[
      { name: cust + vm.$ay.t("Name"), id: "{{Customer}}" },

      {
        name: vm.$ay.t("CustomerServiceRequestRequestedBy"),
        id: "{{CustomerServiceRequestRequestedBy}}"
      },
      {
        name: csr + vm.$ay.t("CustomerServiceRequestCustomerReferenceNumber"),
        id: "{{CustomerServiceRequestCustomerReferenceNumber}}"
      },

      {
        name: csr + vm.$ay.t("CustomerServiceRequestTitle"),
        id: "{{CustomerServiceRequestTitle}}"
      }
    ].sort(window.$gz.util.sortByKey("name"))
  );
}
</script>
